/***************************************************************************
 *  Ce module envoi les trames MODBUS vers ARDUINO et vérifie les réponses *
 *  le mode de trames à envoyer est le suivant :                           *
 *  0x01, 0x06, 0x08, 0x00, 0x00, 0x01, 0x00, 0x00                         *
 *  01 adresse de l'ECH                                                    *
 *  06 code fonction : ici écriture                                         *
 *  adresse 1er registre à lire sur 2 octets : ici 1135 donc 046F en hexa  *
 *  nb de registre à lire sur 2 octets : ici on en lit 1 seul 00 01 en hexa*
 *  et ensuite calcul du CRC de cette trame 0103046F0001 donne CRC16 B5 27 *
 ***************************************************************************/


int ecrit_valeur(int adresse, int valeur) {
  int crc =0;
  int ii;
  int rep=9999;           // cette variable est initialisée à 9999 pour envoyer cette valeur en retour en cas de mauvaise communication
  char buf[]={0x01, 0x10, 0x08, 0x00, 0x00, 0x01, 0x02, 0x00, 0x00, 0x00, 0x00};      // prédimentionnement de la trame d'émission en HEXA
  char reponse[]={0x01, 0x03, 0x02, 0x00, 0x00, 0x00, 0x31, 0xA1};  // prédimentionnement de la trame de réponse en HEXA
  buf[2]= highByte(adresse);                                        // remplacement de l'adresse à lire dans la trame (poids fort)
  buf[3]= lowByte(adresse);                                         // remplacement de l'adresse à lire dans la trame (poids faible)
  buf[7]= highByte(valeur);                                        // remplacement de l'adresse à lire dans la trame (poids fort)
  buf[8]= lowByte(valeur);                                         // remplacement de l'adresse à lire dans la trame (poids faible)
//  String demande = buf;
//  String recep1 = reponse;
  crc=ModRTU_CRC(buf,9);                                            // Calcul du checksum pour la trame à envoyer
//  Serial.println(crc,HEX);
  buf[9]=lowByte(crc);                                              // remplacement du CRC dans la trame (poids fort)
  buf[10]=highByte(crc);                                             // remplacement du CRC dans la trame (poids faible)

     for (int i=0; i <= 10; i++){                                    // à activer pour vérifier la trame envoyée
      Serial.println(buf[i],HEX);                                   //
     }
  
      for (int i=0; i <= 10; i++)                                    //
      {  Serial2.write(buf[i]);                                     // envoi des 8 ocgtets de la trame vers ECH
      }                                                             //
  unsigned long timeout=millis();                 
  while(Serial2.available() == 0)                                   // attente d'une réponse sur le port
  {
    if (millis() - timeout > TIMEOUT)
    {   Serial.println(">>> data Timeout !");                       // si délai dépassé alors sortie de la boucle
        break ;
    }
  }
  if (Serial2.available())
  {    reponse[0]={0x00};
       ii=0;
      Serial.println(">>>réception !");
      while (Serial2.available())
      {    reponse[ii]=Serial2.read();                              // Lecture des différents octets arrivant sur le port comm
           ii++;
      }
      for (int i=0; i <= ii; i++)
      {    Serial.println(reponse[i],HEX);                          // à activer pour vérifier la trame reçue
      }
      Serial.println("");
      Serial.println(ii);

      String recep2 = reponse;
      if (reponse[0]==buf[0] && reponse[1]==buf[1])                 // vérification que la trame reçue commence comme il faut
      { Serial.println("bonne réponse");
      rep=1;                                // conversion de la valeur lue en entier
      } 
      else
      { Serial.print("mauvais message reçu");
        Serial.println(recep2 + " / ");      
      }
  }
  else
  { Serial.print("Pas de réponse");}   
  return (rep);                                                     // retour de la valeur lue
}
