/***************************************************************************
 *  Ce module envoi les trames MODBUS vers ARDUINO et vérifie les réponses *
 *  le mode de trames à envoyer est le suivant :                           *
 *  0x01, 0x03, 0x04, 0x6F, 0x00, 0x01, 0x00, 0x00                         *
 *  01 adresse de l'ECH                                                    *
 *  03 code fonction : ici lecture                                         *
 *  adresse 1er registre à écrire sur 2 octets : ici 2048 donc 0800 en hexa*
 *  nb de registre à écrire sur 1 octets : ici on en écrit 2 _   02 en hexa*
 *  nb bits tjs à 0 sur 1 octets : ici 0                         00 en hexa*
 *  Donnée à écrire à l'adresse indiquée  : ici 0                00 en hexa*
 *  et ensuite calcul du CRC de cette trame 0103046F0001 donne CRC16 B5 27 *
 ***************************************************************************/


int lit_valeur(int adresse) {
  int crc =0;
  int ii;
  int rep=9999;           // cette variable est initialisée à 9999 pour envoyer cette valeur en retour en cas de mauvaise communication
  char buf[]={0x01, 0x03, 0x04, 0x6F, 0x00, 0x01, 0x00, 0x00};      // prédimentionnement de la trame d'émission en HEXA
  char reponse[]={0x01, 0x03, 0x02, 0x00, 0x00, 0x31, 0xA1};  // prédimentionnement de la trame de réponse en HEXA
  buf[2]= highByte(adresse);                                        // remplacement de l'adresse à lire dans la trame (poids fort)
  buf[3]= lowByte(adresse);                                         // remplacement de l'adresse à lire dans la trame (poids faible)
  crc=ModRTU_CRC(buf,6);                                            // Calcul du checksum pour la trame à envoyer
//  Serial.println(crc,HEX);
  buf[6]=lowByte(crc);                                              // remplacement du CRC dans la trame (poids fort)
  buf[7]=highByte(crc);                                             // remplacement du CRC dans la trame (poids faible)

/*  Serial.println("Envoi" + demande + "_");                        //
     for (int i=0; i <= 7; i++){                                    // à activer pour vérifier la trame envoyée
      Serial.println(buf[i],HEX);                                   //
     }
*/  
      for (int i=0; i <= 7; i++)                                    //
      {  Serial2.write(buf[i]);                                     // envoi des 8 ocgtets de la trame vers ECH
      }                                                             //
    delay (100);
    Serial2.flush();

  unsigned long timeout=millis();                 
  while(Serial2.available() == 0)                                   // attente d'une réponse sur le port
  {
    if (millis() - timeout > 1000)
    {   Serial.println(">>> data Timeout !");                       // si délai dépassé alors sortie de la boucle
        return (rep);                                               // retour de la valeur lue
    }
  }
  if (Serial2.available())
  {    reponse[0]={0x00};
       ii=0;
      Serial.println(">>>réception !");
      while (Serial2.available())
      {    reponse[ii]=Serial2.read();                              // Lecture des différents octets arrivant sur le port comm
           ii++;
      }
/*      for (int i=0; i <= ii; i++)
      {    Serial.println(reponse[i],HEX);                          // à activer pour vérifier la trame reçue
      }
      Serial.println("");
      Serial.println(ii);
*/
      crc=ModRTU_CRC(reponse,5);                                            // Calcul du checksum pour la trame reçue
      if ((reponse[5]==lowByte(crc)) && (reponse[6]==highByte(crc)))
        {
          Serial.println("Réponse reçue cohérente");        
          String recep2 = reponse;
          if (reponse[0]==buf[0] && reponse[1]==buf[1]&& reponse[2]==2 && ii==7)                 // vérification que la trame reçue commence comme il faut
          { Serial.println("bonne réponse");
          rep=reponse[3]*256+reponse[4];                                // conversion de la valeur lue en entier
          } 
          else
          { Serial.print("mauvais message reçu");
            Serial.println(recep2 + " / ");      
          }
        }
  }
  else
  { Serial.print("Pas de réponse");}   
  return (rep);                                                     // retour de la valeur lue
}
