/***************************************************************************
 *  Ce module écrit des données sur la carte SD                 *
 ***************************************************************************/

void ecrit_sd(String sd_msg) {
  myFile = SD.open("/temp.csv", FILE_APPEND);   // overture du fichier Temp.csv en ajout

  // si le fichier s'ouvre bien alors on écrit dedans :
  if (myFile)
      {
      Serial.print("Ecriture dans temp.csv...");
      myFile.println(sd_msg);
      myFile.close();
//---
        WiFiClient client;
        Serial.print("connecting to ");
        Serial.println(FTPHOST);
    
        // CONNEXION AU SERVEUR FTP 
        if (!client.connect(FTPHOST, FTPPORT)) {
            Serial.println("la connexion au serveur FTP a échoué");
            return;
        }
        rcvClient(client);
        ftpcde(client, FTPUSER);                      //IDENTIFIANT POUR ECRIRE SUR LE SERVEUR FTP
        ftpcde(client, FTPPASSWORD);                  //MOT DE PASSE DU SERVEUR FTP
        WiFiClient clientData;
        int portFtpData;
        portFtpData=ftpPasvMode(client);
        if (!clientData.connect(FTPHOST, portFtpData)) 
        {
          Serial.println("connection ftp échoué");
          return;
        }
 //---- ENVOI DU FICHIER VALEURS    
        ftpcde(client,"STOR valeurs.txt\r\n");
        clientData.println(sd_msg+"\n");
        clientData.stop();

//------- Lecture du fichier ordre sur FTP
        ordre_ftp="";
        portFtpData=ftpPasvMode(client);
        if (!clientData.connect(FTPHOST, portFtpData)) 
        {
          Serial.println("connection ftp échouée2");
          return;
        }
        ftpcde(client, "RETR ORDRE.txt\r\n");
        ordre_ftp=clientData.readString();      //récupération de l'ordre
        Serial.print("Ordre_FTP"+ordre_ftp);
        clientData.stop();

 //-------- ENVOI DU FICHIER ORDRE EFFACE    
        if (ordre_ftp != "")
          { portFtpData=ftpPasvMode(client);
            ftpcde(client,"STOR ORDRE.txt\r\n");
            if (!clientData.connect(FTPHOST, portFtpData)) 
            {
              Serial.println("connection client data failed");
              return;
            }
            clientData.print("\n");
            clientData.stop();
          }
//-------- ENVOI DU FICHIER VIDE EFFACE    
      
      if (ordre_ftp=="EFFACE")        // si l'ordre efface est reçu alors on efface le fichier sur la carte SD 
      {
        myFile = SD.open("/temp.csv", FILE_WRITE);    
        // if the file opened okay, write to it:
        if (myFile) 
        {
            Serial.print("Efface temp.csv...");
            myFile.println("HEURE; SD1; SD2; SD3; SD4; Temp1; Temp2; Temp4; ventil; entrees; sorties; alarmes");
            myFile.close();
            ordre_ftp="";
        }
      }


       if (ordre_ftp=="UPLOAD" || Heure1 != Heure2)        // si l'ordre efface est reçu alors on efface le fichier sur la carte SD 
      {   Heure2=Heure1;
          // ENVOI DU FICHIER    
          portFtpData=ftpPasvMode(client);
          ftpcde(client,"STOR temp.csv\r\n");           // envoi du fichier temp.csv sur le serveur ftp
          if (!clientData.connect(FTPHOST, portFtpData)) 
          {
            Serial.println("connection ftp échouée");
            return;
          }
        //------- Lecture du fichier sur carte SD pour transfert vers FTP
          myFile = SD.open("/temp.csv", FILE_READ);
          byte clientBuf[64];
          int clientCount = 0;
          Serial.println("remplissage fichier");
          while(myFile.available())
          {
            clientBuf[clientCount] = myFile.read();
            clientCount++;    
            if(clientCount > 63)
            {
              if(clientCount > 0) clientData.write(clientBuf,64); 
              clientCount = 0;
            }     
          }
          if(clientCount > 0) clientData.write(clientBuf,clientCount);
          myFile.close();
          clientData.stop();
      }

  //---  Fermeture des serveurs
       ftpcde(client, "QUIT\r\n");
       Serial.println();
       Serial.println("closing connection");
       client.stop();            
      } 
      else Serial.println("erruer ouverture fichier temp.csv");
}

String rcvClient(WiFiClient client){
  unsigned long timeout=millis();
  while(client.available() == 0)
  {
    if (millis() - timeout > TIMEOUT)
    {
      Serial.println(">>> Client Timeout !");
      client.stop();
      return "";
    }
  }
  String line="";
  while(client.available())
  {
    String lu = client.readStringUntil('\r');
    Serial.print(">>"+lu);
    if (line=="") line = lu;
  }
  return line;
}
//______________  Fin de la fonction rcvClient  _______________________________________________________________________

String ftpcde(WiFiClient client, String cde){
  Serial.println(cde);
  client.print(cde);
//  unsigned long timeout=millis();
  return rcvClient(client);  
}
//_____________  Fin de la fonction ftpcde  ________________________________________________________________________

int ftpPasvMode(WiFiClient client){
  String retPassiveMode=ftpcde(client, "PASV\r\n");
  int indexLastComma = retPassiveMode.lastIndexOf(",");
  String pF= retPassiveMode.substring(retPassiveMode.lastIndexOf(",",indexLastComma-1)+1,indexLastComma);
  String pf= retPassiveMode.substring(indexLastComma+1,retPassiveMode.lastIndexOf(")"));
  int portFtpData = pF.toInt()*256+pf.toInt();
  return portFtpData;
}
//_____________  Fin de la fonction ftpPasvMode  ________________________________________________________________________
