/***************************************************************************
 *  Ce module gère les envois de SMS en cas d'alarme					   *
 ***************************************************************************/
void envoisms(String msgsms) {    // envoi des données vers un message SMS       
          /*
           * L'envoi du SMS se fait en appelant le lien suivant : https://smsapi.free-mobile.fr/sendmsg
          avec les paramètres suivants :
          
          • user :  votre login
          • pass :  votre clé d'identification générée automatiquement par notre service
          • msg :  le contenu du SMS encodé sous forme d'url (Percent-encoding)
          • CHHBzZ9A3LiC8m
          Exemple : Envoyer le message "Hello World !" sur votre mobile :
          
          https://smsapi.free-mobile.fr/sendmsg?user=xxxxxxxx&pass=YYYYYYYYYYYYYYYYYYYYY=Hello%20World%20!
          Vous pouvez également, si vous le préférez, envoyer les paramètres en POST.
          Dans ce cas, le contenu du message n'a pas besoin d'être encodé.
          Le code de retour HTTP indique le succès ou non de l'opération :
          • 200 : Le SMS a été envoyé sur votre mobile.
          • 400 : Un des paramètres obligatoires est manquant.
          • 402 : Trop de SMS ont été envoyés en trop peu de temps.
          • 403 : Le service n'est pas activé sur l'espace abonné, ou login / clé incorrect.
          • 500 : Erreur côté serveur. Veuillez réessayer ultérieurement.
           */
    
            WiFiClientSecure client;
            String url = "/sendmsg?user="+SMS_USER+"&pass="+SMS_PASSWORD+"&msg="+msgsms;
            Serial.print("requesting URL: ");
            Serial.println(url);
              if (!client.connect(host, httpsPort)) 
              {
                Serial.println("connection failed");
                return;
              }    
               client.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" +
               "User-Agent: BuildFailureDetectorESP8266\r\n" +
               "Connection: close\r\n\r\n");
               Serial.println("request sent");
            
              while (client.connected()) 
              {
                String line = client.readStringUntil('\n');
                if (line == "\r") 
                {
                  Serial.println("headers received");
                  break;
                }
              }
}
//_____________  Fin de la fonction envoisms  ________________________________________________________________________
